1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode. "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
5 # Copyright (c) 2006 Johannes E. Schindelin
7 # The original idea comes from Eric W. Biederman, in
8 # http://article.gmane.org/gmane.comp.version-control.git/22407
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user. As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
16 # The rebase command lines that have already been processed. A line
17 # is moved here when it is first handled, before any associated user
19 done="$state_dir"/done
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands. When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it. The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
32 # The first line of the file is of the form
33 # # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated. It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit. (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be. This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
53 rewritten="$state_dir"/rewritten
55 dropped="$state_dir"/dropped
58 msgnum="$state_dir"/msgnum
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
63 author_script="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
84 strategy_args=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
87 for strategy_opt in '"$strategy_opts"'
89 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
93 GIT_CHERRY_PICK_HELP="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
96 comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
100 printf '%s\n' "$*" >&2
103 # Output the commit message for the specified commit.
105 git cat-file commit "$1" | sed "1,/^$/d"
108 orig_reflog_action="$GIT_REFLOG_ACTION"
110 comment_for_reflog () {
111 case "$orig_reflog_action" in
113 GIT_REFLOG_ACTION="rebase -i ($1)"
114 export GIT_REFLOG_ACTION
120 mark_action_done () {
121 sed -e 1q < "$todo" >> "$done"
122 sed -e 1d < "$todo" >> "$todo".new
123 mv -f "$todo".new "$todo"
124 new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
125 echo $new_count >"$msgnum"
126 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
128 if test "$last_count" != "$new_count"
130 last_count=$new_count
131 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
132 test -z "$verbose" || echo
136 # Put the last action marked done at the beginning of the todo list
137 # again. If there has not been an action marked done yet, leave the list of
138 # items on the todo list unchanged.
139 reschedule_last_action () {
140 tail -n 1 "$done" | cat - "$todo" >"$todo".new
141 sed -e \$d <"$done" >"$done".new
142 mv -f "$todo".new "$todo"
143 mv -f "$done".new "$done"
146 append_todo_help () {
150 r, reword = use commit, but edit the commit message
151 e, edit = use commit, but stop for amending
152 s, squash = use commit, but meld into previous commit
153 f, fixup = like \"squash\", but discard this commit's log message
154 x, exec = run command (the rest of the line) using shell
155 d, drop = remove commit
157 These lines can be re-ordered; they are executed from top to bottom.
158 " | git stripspace --comment-lines >>"$todo"
160 if test $(get_missing_commit_check_level) = error
163 Do not remove any line. Use 'drop' explicitly to remove a commit.
164 " | git stripspace --comment-lines >>"$todo"
167 If you remove a line here THAT COMMIT WILL BE LOST.
168 " | git stripspace --comment-lines >>"$todo"
173 sha1_and_parents="$(git rev-list --parents -1 "$1")"
174 case "$sha1_and_parents" in
176 git diff --cc $sha1_and_parents
179 git diff-tree -p "$1^!"
184 esac > "$state_dir"/patch
186 commit_message "$1" > "$msg"
187 test -f "$author_script" ||
188 get_author_ident_from_commit "$1" > "$author_script"
192 echo "$1" > "$state_dir"/stopped-sha
198 echo "$1" > "$state_dir"/stopped-sha
200 git rev-parse --verify HEAD > "$amend"
201 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
202 warn "$(eval_gettext "\
203 You can amend the commit now, with
205 git commit --amend \$gpg_sign_opt_quoted
207 Once you are satisfied with your changes, run
209 git rebase --continue")"
221 test -n "$(git stripspace --strip-comments <"$1")"
225 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
227 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
229 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
230 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
231 test "$tree" = "$ptree"
236 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
239 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
240 # GIT_AUTHOR_DATE exported from the current environment.
243 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
248 git_sequence_editor () {
249 if test -z "$GIT_SEQUENCE_EDITOR"
251 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
252 if [ -z "$GIT_SEQUENCE_EDITOR" ]
254 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
258 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
264 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
265 case "$force_rebase" in '') ;; ?*) ff= ;; esac
266 output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
268 if is_empty_commit "$sha1"
270 empty_args="--allow-empty"
273 test -d "$rewritten" &&
274 pick_one_preserving_merges "$@" && return
275 output eval git cherry-pick \
276 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
277 "$strategy_args" $empty_args $ff "$@"
279 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
280 # previous task so this commit is not lost.
282 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
286 pick_one_preserving_merges () {
297 sha1=$(git rev-parse $sha1)
299 if test -f "$state_dir"/current-commit
301 if test "$fast_forward" = t
303 while read current_commit
305 git rev-parse HEAD > "$rewritten"/$current_commit
306 done <"$state_dir"/current-commit
307 rm "$state_dir"/current-commit ||
308 die "$(gettext "Cannot write current commit's replacement sha1")"
312 echo $sha1 >> "$state_dir"/current-commit
314 # rewrite parents; if none were rewritten, we can fast-forward.
316 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
317 if test "$pend" = " "
321 while [ "$pend" != "" ]
323 p=$(expr "$pend" : ' \([^ ]*\)')
326 if test -f "$rewritten"/$p
328 new_p=$(cat "$rewritten"/$p)
330 # If the todo reordered commits, and our parent is marked for
331 # rewriting, but hasn't been gotten to yet, assume the user meant to
332 # drop it on top of the current HEAD
335 new_p=$(git rev-parse HEAD)
338 test $p != $new_p && fast_forward=f
339 case "$new_parents" in
341 ;; # do nothing; that parent is already there
343 new_parents="$new_parents $new_p"
347 if test -f "$dropped"/$p
350 replacement="$(cat "$dropped"/$p)"
351 test -z "$replacement" && replacement=root
352 pend=" $replacement$pend"
354 new_parents="$new_parents $p"
358 case $fast_forward in
360 output warn "$(eval_gettext "Fast-forward to \$sha1")"
361 output git reset --hard $sha1 ||
362 die "$(eval_gettext "Cannot fast-forward to \$sha1")"
365 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
369 # detach HEAD to current parent
370 output git checkout $first_parent 2> /dev/null ||
371 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
374 case "$new_parents" in
376 test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
379 author_script_content=$(get_author_ident_from_commit $sha1)
380 eval "$author_script_content"
381 msg_content="$(commit_message $sha1)"
382 # No point in merging the first parent, that's HEAD
383 new_parents=${new_parents# $first_parent}
384 merge_args="--no-log --no-ff"
385 if ! do_with_author output eval \
386 'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
387 $merge_args $strategy_args -m "$msg_content" $new_parents'
389 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
390 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
392 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
395 output eval git cherry-pick \
396 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
397 "$strategy_args" "$@" ||
398 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
405 this_nth_commit_message () {
407 eval_gettext "This is the commit message #\${n}:"
410 skip_nth_commit_message () {
412 eval_gettext "The commit message #\${n} will be skipped:"
415 update_squash_messages () {
416 if test -f "$squash_msg"; then
417 mv "$squash_msg" "$squash_msg".bak || exit
419 -e "1s/^$comment_char.*\([0-9][0-9]*\).*/\1/p" \
420 -e "q" < "$squash_msg".bak)+1))
422 printf '%s\n' "$comment_char $(eval_ngettext \
423 "This is a combination of \$count commit." \
424 "This is a combination of \$count commits." \
426 sed -e 1d -e '2,/^./{
428 }' <"$squash_msg".bak
431 commit_message HEAD > "$fixup_msg" || die "$(gettext "Cannot write \$fixup_msg")"
434 printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
435 printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
444 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
450 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
452 # Change the space after the comment character to TAB:
453 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
458 peek_next_command () {
459 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
462 # A squash/fixup has failed. Prepare the long version of the squash
463 # commit message, then die_with_patch. This code path requires the
464 # user to edit the combined commit message for all commits that have
465 # been squashed/fixedup so far. So also erase the old squash
466 # messages, effectively causing the combined commit to be used as the
467 # new basis for any further squash/fixups. Args: sha1 rest
468 die_failed_squash() {
471 mv "$squash_msg" "$msg" || exit
473 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
475 warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
476 die_with_patch $sha1 ""
479 flush_rewritten_pending() {
480 test -s "$rewritten_pending" || return
481 newsha1="$(git rev-parse HEAD^0)"
482 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
483 rm -f "$rewritten_pending"
486 record_in_rewritten() {
487 oldsha1="$(git rev-parse $1)"
488 echo "$oldsha1" >> "$rewritten_pending"
490 case "$(peek_next_command)" in
494 flush_rewritten_pending
502 if test "$(git rev-parse HEAD)" = "$squash_onto"
504 # Set the correct commit message and author info on the
505 # sentinel root before cherry-picking the original changes
506 # without committing (-n). Finally, update the sentinel again
507 # to include these changes. If the cherry-pick results in a
508 # conflict, this means our behaviour is similar to a standard
509 # failed cherry-pick during rebase, with a dirty index to
510 # resolve before manually running git commit --amend then git
512 git commit --allow-empty --allow-empty-message --amend \
513 --no-post-rewrite -n -q -C $sha1 &&
515 git commit --allow-empty --allow-empty-message \
516 --amend --no-post-rewrite -n -q -C $sha1 \
517 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
518 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
521 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
526 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
527 read -r command sha1 rest < "$todo"
529 "$comment_char"*|''|noop|drop|d)
533 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
537 comment_for_reflog pick
540 do_pick $sha1 "$rest"
541 record_in_rewritten $sha1
544 comment_for_reflog reword
547 do_pick $sha1 "$rest"
548 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
549 warn "$(eval_gettext "\
550 Could not amend commit after successfully picking \$sha1... \$rest
551 This is most likely due to an empty commit message, or the pre-commit hook
552 failed. If the pre-commit hook failed, you may need to resolve the issue before
553 you are able to reword the commit.")"
554 exit_with_patch $sha1 1
556 record_in_rewritten $sha1
559 comment_for_reflog edit
562 do_pick $sha1 "$rest"
563 sha1_abbrev=$(git rev-parse --short $sha1)
564 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
565 exit_with_patch $sha1 0
576 comment_for_reflog $squash_style
578 test -f "$done" && has_action "$done" ||
579 die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
582 update_squash_messages $squash_style $sha1
583 author_script_content=$(get_author_ident_from_commit HEAD)
584 echo "$author_script_content" > "$author_script"
585 eval "$author_script_content"
586 if ! pick_one -n $sha1
588 git rev-parse --verify HEAD >"$amend"
589 die_failed_squash $sha1 "$rest"
591 case "$(peek_next_command)" in
593 # This is an intermediate commit; its message will only be
594 # used in case of trouble. So use the long version:
595 do_with_author output git commit --amend --no-verify -F "$squash_msg" \
596 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
597 die_failed_squash $sha1 "$rest"
600 # This is the final command of this squash/fixup group
601 if test -f "$fixup_msg"
603 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
604 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
605 die_failed_squash $sha1 "$rest"
607 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
608 rm -f "$GIT_DIR"/MERGE_MSG
609 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
610 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
611 die_failed_squash $sha1 "$rest"
613 rm -f "$squash_msg" "$fixup_msg"
616 record_in_rewritten $sha1
619 read -r command rest < "$todo"
621 eval_gettextln "Executing: \$rest"
622 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
624 # Run in subshell because require_clean_work_tree can die.
626 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
627 if test "$status" -ne 0
629 warn "$(eval_gettext "Execution failed: \$rest")"
631 warn "$(gettext "and made changes to the index and/or the working tree")"
634 You can fix the problem, and then run
636 git rebase --continue")"
638 if test $status -eq 127 # command not found
643 elif test "$dirty" = t
645 # TRANSLATORS: after these lines is a command to be issued by the user
646 warn "$(eval_gettext "\
647 Execution succeeded: \$rest
648 but left changes to the index and/or the working tree
649 Commit or stash your changes, and then run
651 git rebase --continue")"
657 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
658 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
659 if git rev-parse --verify -q "$sha1" >/dev/null
661 die_with_patch $sha1 "$fixtodo"
667 test -s "$todo" && return
669 comment_for_reflog finish &&
670 newhead=$(git rev-parse HEAD) &&
673 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
674 git update-ref -m "$message" $head_name $newhead $orig_head &&
676 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
680 test ! -f "$state_dir"/verbose ||
681 git diff-tree --stat $orig_head..HEAD
684 test -s "$rewritten_list" &&
685 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
686 true # we don't care if this copying failed
688 hook="$(git rev-parse --git-path hooks/post-rewrite)"
689 if test -x "$hook" && test -s "$rewritten_list"; then
690 "$hook" rebase < "$rewritten_list"
691 true # we don't care if this hook failed
693 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
695 return 1 # not failure; just to break the do_rest loop
698 # can only return 0, when the infinite loop breaks
706 # skip picking commits whose parents are unchanged
707 skip_unnecessary_picks () {
709 while read -r command rest
711 # fd=3 means we skip the command
712 case "$fd,$command" in
714 # pick a commit whose parent is current $onto -> skip
716 case "$(git rev-parse --verify --quiet "$sha1"^)" in
725 3,"$comment_char"*|3,)
732 printf '%s\n' "$command${rest:+ }$rest" >&$fd
733 done <"$todo" >"$todo.new" 3>>"$done" &&
734 mv -f "$todo".new "$todo" &&
735 case "$(peek_next_command)" in
737 record_in_rewritten "$onto"
740 die "$(gettext "Could not skip unnecessary pick commands")"
743 transform_todo_ids () {
744 while read -r command rest
747 "$comment_char"* | exec)
748 # Be careful for oddball commands like 'exec'
749 # that do not have a SHA-1 at the beginning of $rest.
752 sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[ ]*}) &&
753 rest="$sha1 ${rest#*[ ]}"
756 printf '%s\n' "$command${rest:+ }$rest"
757 done <"$todo" >"$todo.new" &&
758 mv -f "$todo.new" "$todo"
765 collapse_todo_ids() {
766 transform_todo_ids --short
769 # Rearrange the todo list that has both "pick sha1 msg" and
770 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
771 # comes immediately after the former, and change "pick" to
774 # Note that if the config has specified a custom instruction format
775 # each log message will be re-retrieved in order to normalize the
776 # autosquash arrangement
777 rearrange_squash () {
778 # extract fixup!/squash! lines and resolve any referenced sha1's
779 while read -r pick sha1 message
781 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
783 "squash! "*|"fixup! "*)
784 action="${message%%!*}"
787 # skip all squash! or fixup! (but save for later)
791 "squash! "*|"fixup! "*)
792 prefix="$prefix${rest%%!*},"
800 printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
801 # if it's a single word, try to resolve to a full sha1 and
802 # emit a second copy. This allows us to match on both message
804 if test "${rest#* }" = "$rest"; then
805 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
806 if test -n "$fullsha"; then
807 # prefix the action to uniquely identify this line as
808 # intended for full sha1 match
809 echo "$sha1 +$action $prefix $fullsha"
814 test -s "$1.sq" || return
817 while read -r pick sha1 message
820 *" $sha1 "*) continue ;;
822 printf '%s\n' "$pick $sha1 $message"
823 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
825 while read -r squash action msg_prefix msg_content
828 *" $squash "*) continue ;;
834 # full sha1 prefix test
835 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
837 # message prefix test
838 case "$message" in "$msg_content"*) emit=1;; esac ;;
840 if test $emit = 1; then
841 if test -n "${format}"
843 msg_content=$(git log -n 1 --format="${format}" ${squash})
845 msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
847 printf '%s\n' "$action $squash $msg_content"
851 done >"$1.rearranged" <"$1"
852 cat "$1.rearranged" >"$1"
853 rm -f "$1.sq" "$1.rearranged"
856 # Add commands after a pick or after a squash/fixup serie
858 add_exec_commands () {
861 while read -r insn rest
869 printf "%s %s\n" "$insn" "$rest"
877 # Check if the SHA-1 passed as an argument is a
878 # correct one, if not then print $2 in "$todo".badsha
879 # $1: the SHA-1 to test
880 # $2: the line number of the input
881 # $3: the input filename
882 check_commit_sha () {
888 sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
889 if test -z "$sha1_verif"
895 if test $badsha -ne 0
897 line="$(sed -n -e "${2}p" "$3")"
898 warn "$(eval_gettext "\
899 Warning: the SHA-1 is missing or isn't a commit in the following line:
907 # prints the bad commits and bad commands
908 # from the todolist in stdin
909 check_bad_cmd_and_sha () {
912 while read -r command rest
914 lineno=$(( $lineno + 1 ))
916 "$comment_char"*|''|noop|x|exec)
917 # Doesn't expect a SHA-1
920 # Work around CR left by "read" (e.g. with Git for
923 pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
924 if ! check_commit_sha "${rest%%[ ]*}" "$lineno" "$1"
930 line="$(sed -n -e "${lineno}p" "$1")"
931 warn "$(eval_gettext "\
932 Warning: the command isn't recognized in the following line:
942 # Print the list of the SHA-1 of the commits
943 # from stdin to stdout
944 todo_list_to_sha_list () {
945 git stripspace --strip-comments |
946 while read -r command sha1 rest
949 "$comment_char"*|''|noop|x|"exec")
952 long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
953 printf "%s\n" "$long_sha"
959 # Use warn for each line in stdin
967 # Switch to the branch in $into and notify it in the reflog
969 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
970 output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
971 git update-ref ORIG_HEAD $orig_head
974 get_missing_commit_check_level () {
975 check_level=$(git config --get rebase.missingCommitsCheck)
976 check_level=${check_level:-ignore}
977 # Don't be case sensitive
978 printf '%s' "$check_level" | tr 'A-Z' 'a-z'
981 # Check if the user dropped some commits by mistake
982 # Behaviour determined by rebase.missingCommitsCheck.
983 # Check if there is an unrecognized command or a
984 # bad SHA-1 in a command.
988 check_level=$(get_missing_commit_check_level)
990 case "$check_level" in
992 # Get the SHA-1 of the commits
993 todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
994 todo_list_to_sha_list <"$todo" >"$todo".newsha1
996 # Sort the SHA-1 and compare them
997 sort -u "$todo".oldsha1 >"$todo".oldsha1+
998 mv "$todo".oldsha1+ "$todo".oldsha1
999 sort -u "$todo".newsha1 >"$todo".newsha1+
1000 mv "$todo".newsha1+ "$todo".newsha1
1001 comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
1003 # Warn about missing commits
1004 if test -s "$todo".miss
1006 test "$check_level" = error && raise_error=t
1009 Warning: some commits may have been dropped accidentally.
1010 Dropped commits (newer to older):")"
1012 # Make the list user-friendly and display
1013 opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
1014 git rev-list $opt <"$todo".miss | warn_lines
1017 To avoid this message, use \"drop\" to explicitly remove a commit.
1019 Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
1020 The possible behaviours are: ignore, warn, error.")"
1027 warn "$(eval_gettext "Unrecognized setting \$check_level for option rebase.missingCommitsCheck. Ignoring.")"
1031 if ! check_bad_cmd_and_sha "$todo"
1036 if test $raise_error = t
1038 # Checkout before the first commit of the
1039 # rebase: this way git rebase --continue
1040 # will work correctly as it expects HEAD to be
1041 # placed before the commit of the next action
1044 warn "$(gettext "You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.")"
1045 die "$(gettext "Or you can abort the rebase with 'git rebase --abort'.")"
1049 # The whole contents of this file is run by dot-sourcing it from
1050 # inside a shell function. It used to be that "return"s we see
1051 # below were not inside any function, and expected to return
1052 # to the function that dot-sourced us.
1054 # However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
1055 # construct and continue to run the statements that follow such a "return".
1056 # As a work-around, we introduce an extra layer of a function
1057 # here, and immediately call it after defining it.
1058 git_rebase__interactive () {
1062 # do we have anything to commit?
1063 if git diff-index --cached --quiet HEAD --
1065 # Nothing to commit -- skip this commit
1067 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1068 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1069 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
1071 if ! test -f "$author_script"
1073 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1074 die "$(eval_gettext "\
1075 You have staged changes in your working tree.
1076 If these changes are meant to be
1077 squashed into the previous commit, run:
1079 git commit --amend \$gpg_sign_opt_quoted
1081 If they are meant to go into a new commit, run:
1083 git commit \$gpg_sign_opt_quoted
1085 In both cases, once you're done, continue with:
1087 git rebase --continue
1090 . "$author_script" ||
1091 die "$(gettext "Error trying to find the author identity to amend commit")"
1094 current_head=$(git rev-parse --verify HEAD)
1095 test "$current_head" = $(cat "$amend") ||
1097 You have uncommitted changes in your working tree. Please commit them
1098 first and then run 'git rebase --continue' again.")"
1099 do_with_author git commit --amend --no-verify -F "$msg" -e \
1100 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1101 die "$(gettext "Could not commit staged changes.")"
1103 do_with_author git commit --no-verify -F "$msg" -e \
1104 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1105 die "$(gettext "Could not commit staged changes.")"
1109 if test -r "$state_dir"/stopped-sha
1111 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1114 require_clean_work_tree "rebase"
1125 git stripspace --strip-comments <"$todo" >"$todo".new
1126 mv -f "$todo".new "$todo"
1130 You are editing the todo file of an ongoing interactive rebase.
1131 To continue rebase after editing, run:
1132 git rebase --continue
1134 " | git stripspace --comment-lines >>"$todo"
1136 git_sequence_editor "$todo" ||
1137 die "$(gettext "Could not execute editor")"
1144 comment_for_reflog start
1146 if test ! -z "$switch_to"
1148 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1149 output git checkout "$switch_to" -- ||
1150 die "$(eval_gettext "Could not checkout \$switch_to")"
1152 comment_for_reflog start
1155 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
1156 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
1158 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
1160 if test t = "$preserve_merges"
1162 if test -z "$rebase_root"
1164 mkdir "$rewritten" &&
1165 for c in $(git merge-base --all $orig_head $upstream)
1167 echo $onto > "$rewritten"/$c ||
1168 die "$(gettext "Could not init rewritten commits")"
1171 mkdir "$rewritten" &&
1172 echo $onto > "$rewritten"/root ||
1173 die "$(gettext "Could not init rewritten commits")"
1175 # No cherry-pick because our first pass is to determine
1176 # parents to rewrite and skipping dropped commits would
1177 # prematurely end our probe
1180 merges_option="--no-merges --cherry-pick"
1183 shorthead=$(git rev-parse --short $orig_head)
1184 shortonto=$(git rev-parse --short $onto)
1185 if test -z "$rebase_root"
1186 # this is now equivalent to ! -z "$upstream"
1188 shortupstream=$(git rev-parse --short $upstream)
1189 revisions=$upstream...$orig_head
1190 shortrevisions=$shortupstream..$shorthead
1192 revisions=$onto...$orig_head
1193 shortrevisions=$shorthead
1195 format=$(git config --get rebase.instructionFormat)
1196 # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1197 git rev-list $merges_option --format="%m%H ${format:-%s}" \
1198 --reverse --left-right --topo-order \
1199 $revisions ${restrict_revision+^$restrict_revision} | \
1201 while read -r sha1 rest
1204 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1206 comment_out="$comment_char "
1211 if test t != "$preserve_merges"
1213 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1215 if test -z "$rebase_root"
1218 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1220 if test -f "$rewritten"/$p
1228 if test f = "$preserve"
1230 touch "$rewritten"/$sha1
1231 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1236 # Watch for commits that been dropped by --cherry-pick
1237 if test t = "$preserve_merges"
1240 # Save all non-cherry-picked changes
1241 git rev-list $revisions --left-right --cherry-pick | \
1242 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1243 # Now all commits and note which ones are missing in
1244 # not-cherry-picks and hence being dropped
1245 git rev-list $revisions |
1248 if test -f "$rewritten"/$rev &&
1249 ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1251 # Use -f2 because if rev-list is telling us this commit is
1252 # not worthwhile, we don't want to track its multiple heads,
1253 # just the history of its first-parent for others that will
1254 # be rebasing on top of it
1255 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1256 sha1=$(git rev-list -1 $rev)
1257 sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1258 rm "$rewritten"/$rev
1263 test -s "$todo" || echo noop >> "$todo"
1264 test -n "$autosquash" && rearrange_squash "$todo"
1265 test -n "$cmd" && add_exec_commands "$todo"
1267 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1268 todocount=${todocount##* }
1272 $comment_char $(eval_ngettext \
1273 "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
1274 "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
1279 However, if you remove everything, the rebase will be aborted.
1281 " | git stripspace --comment-lines >>"$todo"
1283 if test -z "$keep_empty"
1285 printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
1289 has_action "$todo" ||
1292 cp "$todo" "$todo".backup
1294 git_sequence_editor "$todo" ||
1295 die_abort "$(gettext "Could not execute editor")"
1297 has_action "$todo" ||
1304 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1310 # ... and then we call the whole thing.
1311 git_rebase__interactive